// ConfigDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "ConfigDlg.h"

#include "NeMessengerDlg.h"
#include "main_frame.hpp"

IMPLEMENT_DYNAMIC(CConfigDlg, CDialog)

CConfigDlg::CConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDlg::IDD, pParent)
{
	//m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_ConfigType = CONFIG_BASIC;
}

CConfigDlg::~CConfigDlg()
{
}

void CConfigDlg::InitSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	// LosdSkin()   ׸    .
	//  ׸ ϱ ؼ SetWindowsTheme  ̿ؾ .
	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("ConfigDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

BOOL CConfigDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_RETURN)
		{			
			return TRUE;
		}
	}
	else if(pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}
void CConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CONFIG_BASIC_BUTTON, m_btnBasic);
	DDX_Control(pDX, IDC_CONFIG_PERSONAL_BUTTON, m_btnPersonal);
	DDX_Control(pDX, IDC_CONFIG_MEMO_BUTTON, m_btnMemo);
	DDX_Control(pDX, IDC_CONFIG_VIEW_BUTTON, m_btnView);
	DDX_Control(pDX, IDC_CONFIG_SOUND_BUTTON, m_btnSound);
	DDX_Control(pDX, IDC_SAVE_BUTTON, m_btnSave);
	DDX_Control(pDX, IDC_CANCEL_BUTTON, m_btnCancel);
	DDX_Control(pDX, IDC_BUTTON2, m_btnClose);
}

BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
	ON_BN_CLICKED(IDC_CONFIG_BASIC_BUTTON, &CConfigDlg::OnBnClickedConfigBasicButton)
	ON_BN_CLICKED(IDC_CONFIG_PERSONAL_BUTTON, &CConfigDlg::OnBnClickedConfigPersonalButton)
	ON_BN_CLICKED(IDC_CONFIG_MEMO_BUTTON, &CConfigDlg::OnBnClickedConfigMemoButton)
	ON_BN_CLICKED(IDC_CONFIG_VIEW_BUTTON, &CConfigDlg::OnBnClickedConfigViewButton)
	ON_BN_CLICKED(IDC_CONFIG_SOUND_BUTTON, &CConfigDlg::OnBnClickedConfigSoundButton)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CANCEL_BUTTON, &CConfigDlg::OnBnClickedCancelButton)
	ON_BN_CLICKED(IDC_SAVE_BUTTON, &CConfigDlg::OnBnClickedSaveButton)
	ON_WM_NCHITTEST()
	ON_BN_CLICKED(IDC_BUTTON2, &CConfigDlg::OnBnClickedButton2)
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()
void CConfigDlg::__ResourceLoad(BOOL bInit)
{	
	if(bInit == TRUE)
	{		
		int nTabSize = 70;
		m_btnBasic.MoveWindow(0, 0, nTabSize, 35, TRUE);
		m_btnBasic.SetFont(&g_ftDefault9PTB);// g_ftNanum13PX);
		m_btnBasic.SetTextColor(BTN_SELECTED_TEXT_COLOR,BTN_NORMAL_TEXT_COLOR);
		m_btnBasic.SetButtonText(LoadStringFromResource(IDS_STRING412));

		m_btnPersonal.MoveWindow(0 + nTabSize, 0, nTabSize, 35, TRUE);
		m_btnPersonal.SetFont(&g_ftDefault9PTB);//g_ftNanum13PX);
		m_btnPersonal.SetTextColor(BTN_SELECTED_TEXT_COLOR,BTN_NORMAL_TEXT_COLOR);
		m_btnPersonal.SetButtonText(LoadStringFromResource(IDS_STRING413));

		m_btnMemo.MoveWindow(0 + nTabSize + nTabSize, 0, nTabSize + 42, 35, TRUE);
		m_btnMemo.SetFont(&g_ftDefault9PTB);//g_ftNanum13PX);
		m_btnMemo.SetTextColor(BTN_SELECTED_TEXT_COLOR,BTN_NORMAL_TEXT_COLOR);
		m_btnMemo.SetButtonText(LoadStringFromResource(IDS_STRING414));

		m_btnView.MoveWindow(0 + nTabSize + nTabSize + nTabSize + 42, 0, nTabSize , 35, TRUE);
		m_btnView.SetFont(&g_ftDefault9PTB);//g_ftNanum13PX);
		m_btnView.SetTextColor(BTN_SELECTED_TEXT_COLOR,BTN_NORMAL_TEXT_COLOR);
		m_btnView.SetButtonText(LoadStringFromResource(IDS_STRING415));

		m_btnSound.MoveWindow(0 + nTabSize + nTabSize + nTabSize + 42 + nTabSize, 0, nTabSize , 35, TRUE);
		m_btnSound.SetFont(&g_ftDefault9PTB);//g_ftNanum13PX);
		m_btnSound.SetTextColor(BTN_SELECTED_TEXT_COLOR,BTN_NORMAL_TEXT_COLOR);
		m_btnSound.SetButtonText(LoadStringFromResource(IDS_STRING416));
	
		m_btnSave.SetWindowText(LoadStringFromResource(IDS_STRING568));

		MoveWindow(0,0,DEF_CONFIG_DLG_SIZE_CX  -2 ,DEF_CONFIG_DLG_SIZE_CY);
		CenterWindow();
	}

	//if(g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{
		m_btnBasic.SetTabBitmapFile(GetAppImgFile(_T("tab01-1.bmp")),RGB(0,0,0));
		m_btnPersonal.SetTabBitmapFile(GetAppImgFile(_T("tab01-1.bmp")),RGB(0,0,0));
		m_btnMemo.SetTabBitmapFile(GetAppImgFile(_T("tab01-2.bmp")),RGB(0,0,0));
		m_btnView.SetTabBitmapFile(GetAppImgFile(_T("tab01-1.bmp")),RGB(0,0,0));
		m_btnSound.SetTabBitmapFile(GetAppImgFile(_T("tab01-1.bmp")),RGB(0,0,0));

		m_btnSave.SetFont(&g_ftDefault13PX);
		m_btnCancel.SetFont(&g_ftDefault13PX);
		m_btnSave.MoveWindow(110,331,78,28,TRUE);
		m_btnCancel.MoveWindow(212,331,78,28,TRUE);
	}

	
	if(bInit == FALSE)
		Invalidate();	
}

BOOL CConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitSkin();	
	__ResourceLoad(TRUE);
	SetWindowText(LoadStringFromResource(IDS_STRING530));
	
	m_ConfigBasic.Create(CConfigBasic::IDD,this);
	m_ConfigMemo.Create(CConfigMemo::IDD,this);
	m_ConfigPersonal.Create(CConfigPersonal::IDD,this);
	m_ConfigView.Create(CConfigView::IDD,this);
	m_ConfigSound.Create(CConfigSound::IDD, this);

	//ùȭ Basicȭ .
	OnBnClickedConfigBasicButton();

	return TRUE;
}

void CConfigDlg::SetSelectButton(CNMImgTabButton* pSelectButton)
{
	CNMImgTabButton* buttons[5] = 
	{
		&m_btnBasic,
		&m_btnPersonal,
		&m_btnMemo,
		&m_btnView,
		&m_btnSound
	};
	for (int i = 0; i < (int)_countof(buttons); i++)
	{
		if (pSelectButton == buttons[i])
		{
			buttons[i]->SetFont(&g_ftDefault10PTB);
		}
		else
		{
			buttons[i]->SetFont(&g_ftDefault9PTB);
		}
	}
}

void CConfigDlg::OnBnClickedConfigBasicButton()
{
	m_ConfigType=CONFIG_BASIC;
	m_ConfigBasic.ShowChild();
	m_btnBasic.SetTapSelected();
	m_btnPersonal.SetTapUnSelected();
	m_btnMemo.SetTapUnSelected();
	m_btnView.SetTapUnSelected();
	m_btnSound.SetTapUnSelected();

	SetSelectButton(&m_btnBasic);
}

void CConfigDlg::OnBnClickedConfigPersonalButton()
{
	m_ConfigType=CONFIG_PERSONAL;
	m_ConfigPersonal.ShowChild();
	m_btnBasic.SetTapUnSelected();
	m_btnPersonal.SetTapSelected();
	m_btnMemo.SetTapUnSelected();
	m_btnView.SetTapUnSelected();
	m_btnSound.SetTapUnSelected();

	SetSelectButton(&m_btnPersonal);
}

void CConfigDlg::OnBnClickedConfigMemoButton()
{
	m_ConfigType=CONFIG_MEMO;
	m_ConfigMemo.ShowChild();
	m_btnBasic.SetTapUnSelected();
	m_btnPersonal.SetTapUnSelected();
	m_btnMemo.SetTapSelected();
	m_btnView.SetTapUnSelected();
	m_btnSound.SetTapUnSelected();

	SetSelectButton(&m_btnMemo);
}

void CConfigDlg::OnBnClickedConfigViewButton()
{
	m_ConfigType=CONFIG_VIEW;
	m_ConfigView.ShowChild();
	m_btnBasic.SetTapUnSelected();
	m_btnPersonal.SetTapUnSelected();
	m_btnMemo.SetTapUnSelected();
	m_btnView.SetTapSelected();
	m_btnSound.SetTapUnSelected();

	SetSelectButton(&m_btnView);
}

void CConfigDlg::OnBnClickedConfigSoundButton()
{
	
	m_ConfigType=CONFIG_SOUND;
	m_ConfigSound.ShowChild();
	m_btnBasic.SetTapUnSelected();
	m_btnPersonal.SetTapUnSelected();
	m_btnMemo.SetTapUnSelected();
	m_btnView.SetTapUnSelected();
	m_btnSound.SetTapSelected();

	SetSelectButton(&m_btnSound);
}



void CConfigDlg::OnDestroy()
{
	CDialog::OnDestroy();

	if (m_ConfigBasic.GetSafeHwnd())
	{
		m_ConfigBasic.DestroyWindow();
	}
	if(m_ConfigMemo.GetSafeHwnd())
	{
		m_ConfigMemo.DestroyWindow();
	}
	if(m_ConfigPersonal.GetSafeHwnd())
	{
		m_ConfigPersonal.DestroyWindow();
	}
	if(m_ConfigView.GetSafeHwnd())
	{
		m_ConfigView.DestroyWindow();
	}

	if(m_ConfigSound.GetSafeHwnd())
	{
		m_ConfigSound.DestroyWindow();
	}
}


void CConfigDlg::OnBnClickedCancelButton()
{
	CDialog::OnCancel();
	DestroyWindow();
}

void CConfigDlg::OnBnClickedSaveButton()
{
	UpdateData(TRUE);
	if(false == m_ConfigPersonal.DoApply())
	{
		// ȭ   ڿ   â  ʰ ȭ  â ̵Ѵ.
		OnBnClickedConfigPersonalButton();
		return; 
	}

	m_ConfigBasic.DoApply();
	
	m_ConfigMemo.DoApply();	
	m_ConfigView.DoApply();
	m_ConfigSound.DoApply();
	GET_CONFIG()->SaveClientConfig();
	g_stNtalkInfo.nLang = GET_CONFIG()->GetLanguage();
	

	GET_MESSENGER_DLG()->GetLanuageActorEvent()->RequestSetLanguage(GetLanguageStringUnicode());

	////ٱ ۾ Ϸ  ʾ ´.
	//GET_APP()->SetLangPack(g_stNtalkInfo.nLang);
	ShowWindow(SW_HIDE);
	if(GET_CONFIG()->GetAutoStart() == 1)
	{
		GET_CONFIG()->AppAutoStart(TRUE);
	}
	else
	{
		GET_CONFIG()->AppAutoStart(FALSE);

	}

	GET_MESSENGER_DLG()->ProcRenameTalkname(GET_CONFIG()->GetChangeNickName());
	if (NULL != GET_MESSENGER_DLG()->GetMainFrame()->GetFavoriteTreeCtrl())
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateAllBuddyDisplayNames();

	GET_MESSENGER_DLG()->GetMainFrame()->RedrawOutlink();

	GET_MESSENGER_DLG()->CloseModalDlg(TRUE);

	CDialog::OnOK();	
}

LRESULT CConfigDlg::OnNcHitTest(CPoint point)
{
	return HTCAPTION;
}

void CConfigDlg::OnBnClickedButton2()
{	
	CDialog::OnCancel();
}

BOOL CConfigDlg::OnEraseBkgnd(CDC* pDC)
{
	CDialog::OnEraseBkgnd(pDC);
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);

	pDC->FillSolidRect(rcClient.left, rcClient.bottom - 49 , rcClient.Width() , CONFIG_DLG_BORDER_PIXEL ,CONFIG_DLG_BORDER_COLOR);

	return TRUE;
}
